/* Snackbar */
function resetsnackbar() {
	var snacktext = "";
	var snackactiontext = "";
	var snackaction = "hidesnackbar()";
	var snackactioncolor = "";
	var snacktimeout = 0;
	var snackoverlay = 0;
	var snackhideoverlay = 0;
	var snackautohide = 0;
}

function showsnackbar() {
	$(".snackbar").html('<div class="text" id=""></div><div><a class="action btn btn-flat btn-brand waves-attach waves-button waves-light" onclick=""></a></div>');
	$(".text").html(snacktext);
	$(".action").html(snackactiontext);
	$(".action").attr("onclick", snackaction);
	$('.action').addClass(snackactioncolor);
	$('.snackbar').removeClass('hidden');
	if(snackoverlay == 1) {
		$('.overlay').fadeIn("fast");
	}
	if(snackautohide == 1) {
		autohidesnackbar();
	}
}

function autohidesnackbar() {
	setTimeout(function() {
		$('.snackbar').addClass('hidden');
	    $('.overlay').fadeOut("fast");
		resetsnackbar();
	}, snacktimeout);
}

function hidesnackbar() {
	$('.snackbar').addClass('hidden');
	$('.overlay').fadeOut("fast");	
	resetsnackbar();
}

$('.overlay').click(function(){
if(snackhideoverlay == 1) {
	$('.overlay').fadeOut("fast");
}
});

/* Device Deady */
document.addEventListener("deviceready", onDeviceReady, false);

var gaPlugin;

function onDeviceReady() {
//navigator.splashscreen.hide();//Splash Screen hide
resetsnackbar();
gaPlugin = window.plugins.gaPlugin;
gaPlugin.init(nativePluginResultHandler, nativePluginErrorHandler, "UA-66848210-3", 10);
document.addEventListener("backbutton", onBackKeyDown, false);
document.addEventListener("volumeupbutton", onVolumeUpKeyDown, false);
document.addEventListener("volumedownbutton", onVolumeDownKeyDown, false);
document.addEventListener("menubutton", menuKeyDown, false);
window.addEventListener("batterylow", onBatteryLow, false);
}

$(window).load(function() {
	snacktext = "Welcome to XO!";
	snackactiontext = "PLAY";
	snackaction = "play()";
	snackactioncolor = "blue";
	snacktimeout = 5000;
    snackoverlay = 1;
    snackhideoverlay = 1;
    snackautohide = 0;
	showsnackbar();
	$(function(){
		$('#setsound').attr('checked', 'checked');
		$('#setvibrate').attr('checked', 'checked');
		$('#setzoom').attr('checked', 'checked');
	});
	if($(window).width() < 450) {
		$(".board").width(300);
		$(".board").height(300);
		$(".board").show();
	}
		
	var admobid = {};
	admobid = {
		banner: 'ca-app-pub-8189859395976945/2094437319'
	};
	AdMob.createBanner( admobid.banner );

	AdMob.createBanner({
		adId: admobid.banner,
		position: AdMob.AD_POSITION.TOP_CENTER,
		autoShow: true,
		success: function(){
			console.log('succeded to create banner');
		},
		error: function(){
			console.log('failed to create banner');
		}
	});
});

window.onresize = function(event) {
	if($(window).width() < 450) {
		$(".board").width(300);
		$(".board").height(300);
		$(".board").show();
	}
	else {
		$(".board").width(425);
		$(".board").height(425);		
	}
};

/* Volume Controls */
function onVolumeUpKeyDown() {
	$('#scale-Up').click();
}

function onVolumeDownKeyDown() {
	$('#scale-Down').click();
}

/* Menu button */
function menuKeyDown() {
	$('.xo-stretchy-nav').addClass('nav-is-visible');
}

/* Analytics */
function nativePluginResultHandler (result) {
	console.log('nativePluginResultHandler: '+result);
}
function nativePluginErrorHandler (error) {
	console.log('nativePluginErrorHandler: '+error);
}
function goingAway() {
	gaPlugin.exit(nativePluginResultHandler, nativePluginErrorHandler);
}
					
/* App Share */
function appShare() {
    window.plugins.socialsharing.share('Check out XO! It is a modified version of the classic table game Gomoku. Choose either X or O and start the game. Try to make 5 continuously in a row or column or diagonally before your computer opponent. It is a mindboggling game by Shreyans Chandak. Play online at - http://xo.shreyanschandak.com or download the android app at - ', 'Check out XO!', null, 'http://bit.ly/xo-googleplay')
	gaPlugin.trackEvent( nativePluginResultHandler, nativePluginErrorHandler, "AppShare", "Click", "event only", 1);
}

/* App Exit Menu */
function onBackKeyDown() {
	navigator.notification.confirm(
		"Do you want to exit XO?", // the message
		function( index ) {
			switch ( index ) {
				case 1:
					window.open('market://details?id=com.shreyanschandak.xo', '_system');
					break;
				case 2:
					appShare();
					break;
				case 3:
					navigator.app.exitApp();
					break;
			}
		},
		"Exit", // a title
		[ "RATE", "SHARE", "EXIT" ] // text of the buttons
	);
}

/* Capture and Share Screenshot */
function sharePhoto() {
	$('.overlay').fadeOut("fast");
	setTimeout(function() {
		capture();
	}, 700);
	AdMob.hideBanner();
}
function capture() {
	var imageLink;
	navigator.screenshot.save(function(error,res){
		if(error){
			console.error(error);
		}
		else {
			console.log('ok',res.filePath);
			imageLink = res.filePath;
			window.plugins.socialsharing.share('I just won a game of XO! Check out my amazing victory! #xo #xogame #shreyanschandak', 'Won a game of XO','file://'+imageLink, null);
		}
	},'jpg','myScreenShot');
	gaPlugin.trackEvent( nativePluginResultHandler, nativePluginErrorHandler, "WonShare", "Click", "event only", 1);
	AdMob.showBanner(AdMob.AD_POSITION.TOP_CENTER);
}
function camera() {
	hidesnackbar();
	$('.statesnackbar').removeClass('hidden');
	AdMob.hideBanner();
	setTimeout(function() {
		$('.statesnackbar').addClass('hidden');
	}, 2500);
	setTimeout(function() {
		delay();
	}, 700);
}
function delay() {
		var imageLink;
		navigator.screenshot.save(function(error,res){
			if(error){
				console.error(error);
			}
			else {
				console.log('ok',res.filePath);
				imageLink = res.filePath;
				window.plugins.socialsharing.share(null, null,'file://'+imageLink, null);
			}
		},'jpg','myScreenShot');
	gaPlugin.trackEvent( nativePluginResultHandler, nativePluginErrorHandler, "Share", "Click", "event only", 1);
	AdMob.showBanner(AdMob.AD_POSITION.TOP_CENTER);
}

/* Navigation */
if( $('.xo-stretchy-nav').length > 0 ) {
	var stretchyNavs = $('.xo-stretchy-nav');
	
	stretchyNavs.each(function(){
		var stretchyNav = $(this),
			stretchyNavTrigger = stretchyNav.find('.xo-nav-trigger');
		
		stretchyNavTrigger.on('click', function(event){
			event.preventDefault();
			stretchyNav.toggleClass('nav-is-visible');
		});
	});

	$(document).on('click', function(event){
		( !$(event.target).is('.xo-nav-trigger') && !$(event.target).is('.xo-nav-trigger span') ) && stretchyNavs.removeClass('nav-is-visible');
	});
}

/* You are X */
$('#new-X').parent().click(function(){
	snacktext = "You are X!";
	snackactiontext = "";
    snackaction = "";
	snackactioncolor = "";
	snacktimeout = 2000;
    snackoverlay = 0;
    snackhideoverlay = 0;
    snackautohide = 1;
	showsnackbar();
	gaPlugin.trackEvent( nativePluginResultHandler, nativePluginErrorHandler, "X", "Click", "event only", 1);
});

/* You are O */
$('#new-O').parent().click(function(){
	snacktext = "You are O!";
	snackactiontext = "";
    snackaction = "";
	snackactioncolor = "";
	snacktimeout = 2000;
    snackoverlay = 0;
    snackhideoverlay = 0;
    snackautohide = 1;
	showsnackbar();
	gaPlugin.trackEvent( nativePluginResultHandler, nativePluginErrorHandler, "O", "Click", "event only", 1);
});

/* Choose X or O */
//new game popup
function play(){
	closeSettings();
	event.preventDefault();
	$('#playgame').addClass('is-visible');
	$('.overlay').fadeOut("fast");
	hidesnackbar();
	gaPlugin.trackEvent( nativePluginResultHandler, nativePluginErrorHandler, "Play", "Click", "event only", 1);
}
//close new game popup
function closepopup(){
	event.preventDefault();
	$('#playgame').removeClass('is-visible');
	$('.overlay').fadeOut("fast");
}

/* Settings */
//settings popup
function showSettings(){
	event.preventDefault();
	$('#settings').addClass('is-visible');
	$('.overlay').fadeOut("fast");
}
//close settings popup
function closeSettings(){
	event.preventDefault();
	$('#settings').removeClass('is-visible');
	$('.overlay').fadeOut("fast");
}

/* Low Battery */
function onBatteryLow() {
	navigator.notification.confirm(
		"Do you want to continue XO?", // the message
		function( index ) {
			switch ( index ) {
				case 1:
					play();
					break;
				case 2:
					navigator.app.exitApp();
					break;
			}
		},
		"Battery Low", // a title
		[ "PLAY", "EXIT" ] // text of the buttons
	);
}

/* Game Logic */
! function r(e, n, t) {
 function a(i, f) {
  if (!n[i]) {
   if (!e[i]) {
    var u = "function" == typeof require && require;
    if (!f && u) return u(i, !0);
    if (o) return o(i, !0);
    var l = new Error("Cannot find module '" + i + "'");
    throw l.code = "MODULE_NOT_FOUND", l
   }
   var s = n[i] = {
    exports: {}
   };
   e[i][0].call(s.exports, function(r) {
    var n = e[i][1][r];
    return a(n ? n : r)
   }, s, s.exports, r, e, n, t)
  }
  return n[i].exports
 }
 for (var o = "function" == typeof require && require, i = 0; i < t.length; i++) a(t[i]);
 return a
}({
 1: [function(r, e) {
  e.exports = function() {
   var r = [
     [1, 1, 1, 1, 1]
    ],
    e = [
     [0, 1, 1, 1, 1, 0]
    ],
    n = [
     [0, 1, 1, 1, 0, 0],
     [0, 0, 1, 1, 1, 0],
     [0, 1, 0, 1, 1, 0],
     [0, 1, 1, 0, 1, 0]
    ],
    t = [
     [0, 0, 1, 1, 0, 0],
     [0, 1, 0, 1, 0, 0],
     [0, 0, 1, 0, 1, 0],
     [0, 1, 1, 0, 0, 0],
     [0, 0, 0, 1, 1, 0],
     [0, 1, 0, 0, 1, 0]
    ],
    a = [
     [-1, 1, 0, 1, 1, 1],
     [-1, 1, 1, 0, 1, 1],
     [-1, 1, 1, 1, 0, 1],
     [-1, 1, 1, 1, 1, 0],
     [0, 1, 1, 1, 1, -1],
     [1, 0, 1, 1, 1, -1],
     [1, 1, 0, 1, 1, -1],
     [1, 1, 1, 0, 1, -1]
    ],
    o = [
     [-1, 1, 1, 1, 0, 0],
     [-1, 1, 1, 0, 1, 0],
     [-1, 1, 0, 1, 1, 0],
     [0, 0, 1, 1, 1, -1],
     [0, 1, 0, 1, 1, -1],
     [0, 1, 1, 0, 1, -1],
     [-1, 1, 0, 1, 0, 1, -1],
     [-1, 0, 1, 1, 1, 0, -1],
     [-1, 1, 1, 0, 0, 1, -1],
     [-1, 1, 0, 0, 1, 1, -1]
    ];
   ! function() {
    for (var i = [r, e, n, t, a, o], f = 0; f < i.length; f++) {
     for (var u = [], l = 0; l < i[f].length; l++) {
      for (var s = [], v = 0; v < i[f][l].length; v++) s[v] = -i[f][l][v];
      u.push(s)
     }
     for (var c = 0; c < u.length; c++) i[f].push(u[c])
    }
   }();
   var i = function(r, e, n, t, a, o) {
     if (r > 0) return 1e9;
     if (t > 0) return 1e8;
     if (o > 1) return 1e7;
     if (n > 0 && o > 0) return 1e6;
     if (n > 1) return 1e5;
     if (1 == n) return 3 == e ? 4e4 : 2 == e ? 38e3 : 1 == e ? 35e3 : 3450;
     if (1 == o) return 3 == e ? 4500 : 2 == e ? 4200 : 1 == e ? 4100 : 4050;
     if (1 == a) {
      if (3 == e) return 3400;
      if (2 == e) return 3300;
      if (1 == e) return 3100
     }
     if (2 == a) {
      if (2 == e) return 3e3;
      if (1 == e) return 2900
     }
     return 3 == a && 1 == e ? 2800 : 4 == e ? 2700 : 3 == e ? 2500 : 2 == e ? 2e3 : 1 == e ? 1e3 : 0
    },
    f = function(r, e) {
     for (var n, t = r.length, a = e.length, o = 0; t - a >= o; o++) {
      n = 0;
      for (var i = 0; a > i && r[o + i] == e[i]; i++) n++;
      if (n == a) return !0
     }
     return !1
    },
    u = function(r, e) {
     for (var n = 0; n < r.length; n++)
      if (f(e, r[n])) return !0;
     return !1
    },
    l = {};
   return l.winValue = 1e9, l.valuePosition = function(f, l, s, v) {
    for (var c = 0, d = 0, h = 0, C = 0, g = 0, p = 0, m = [f, l, s, v], b = 0; b < m.length; b++) u(r, m[b]) ? c++ : u(a, m[b]) ? p++ : u(o, m[b]) ? g++ : u(e, m[b]) ? C++ : u(n, m[b]) ? h++ : u(t, m[b]) && d++;
    return i(c, d, h, C, g, p)
   }, l
  }
 }, {}],
 2: [function(r, e) {
  Array.matrix = function(r, e, n) {
   var t, a, o, i = [];
   for (a = 0; r > a; a++) {
    for (t = [], o = 0; e > o; o++) t[o] = n;
    i[a] = t
   }
   return i
  };
  var n = r("./combinations");
  e.exports = function(r) {
   var e = 5,
    t = 1,
    a = !1,
    o = 15,
    i = Array.matrix(15, 15, 0),
    f = r || -1,
    u = n(); - 1 === f && (i[7][7] = 1);
   var l = function() {
     for (var r = 0; o > r; r++)
      for (var e = 0; o > e; e++)
       if (0 != i[r][e]) {
        var n = u.valuePosition(d(i, i[r][e], r, e, 1, 0), d(i, i[r][e], r, e, 0, 1), d(i, i[r][e], r, e, 1, 1), d(i, i[r][e], r, e, 1, -1));
        n === u.winValue && (a = !0)
       }
    },
    s = function g(r, e, n, t) {
     if (0 == e) return h(r, t);
     for (var a = Number.MIN_VALUE, o = c(r, n), i = 0; i < o.length; i++) a = Math.max(a, -g(o[i], e - 1, -n, r));
     return a
    },
    v = function(r, e, n) {
     for (var t = 0, a = 0; a < r.length; a++)(e != r[a][0] || n != r[a][1]) && t++;
     return t == r.length
    },
    c = function(r, e) {
     for (var n = [], a = [], i = 0; o > i; i++)
      for (var f = 0; o > f; f++)
       if (0 != r[i][f])
        for (var u = i - t; i + t >= u; u++)
         for (var l = f - t; f + t >= l; l++)
          if (u >= 0 && l >= 0 && o > u && o > l && 0 == r[u][l]) {
           var s = [u, l],
            c = v(a, s[0], s[1]);
           c && a.push(s)
          }
     for (var d = 0; d < a.length; d++) {
      for (var h = Array.matrix(o, o, 0), C = 0; o > C; C++)
       for (var g = 0; o > g; g++) h[C][g] = r[C][g];
      h[a[d][0]][a[d][1]] = -e, n.push(h)
     }
     return n
    },
    d = function(r, n, t, a, i, f) {
     for (var u = [n], l = 1; e > l; l++) {
      var s = t - i * l,
       v = a - f * l;
      if (s >= o || v >= o || 0 > s || 0 > v) break;
      var c = r[s][v];
      if (r[s][v] == -n) {
       u.unshift(c);
       break
      }
      u.unshift(c)
     }
     for (var d = 1; e > d; d++) {
      var h = t + i * d,
       C = a + f * d;
      if (h >= o || C >= o || 0 > h || 0 > C) break;
      var g = r[h][C];
      if (g == -n) {
       u.push(g);
       break
      }
      u.push(g)
     }
     return u
    },
    h = function(r, e) {
     for (var n = 0; o > n; n++)
      for (var t = 0; o > t; t++)
       if (r[n][t] != e[n][t]) {
        var a = r[n][t],
         i = u.valuePosition(d(r, a, n, t, 1, 0), d(r, a, n, t, 0, 1), d(r, a, n, t, 1, 1), d(r, a, n, t, 1, -1));
        r[n][t] = -a;
        var f = u.valuePosition(d(r, -a, n, t, 1, 0), d(r, -a, n, t, 0, 1), d(r, -a, n, t, 1, 1), d(r, -a, n, t, 1, -1));
        return r[n][t] = -a, 2 * i + f
       }
     return 0
    },
    C = {};
   return C.winState = "", C.makeAnswer = function(r, e) {
    var n = this;
    if (i[r][e] = f, l(), a) return n.winState = "You Won!", "";
    for (var t = [-1, -1], u = c(i, f), v = -1, d = Number.MIN_VALUE, h = 0; h < u.length; h++) {
     var C = s(u[h], 0, -f, i);
     C > d && (d = C, v = h)
    }
    for (var g = 0; o > g; g++)
     for (var p = 0; o > p; p++)
      if (u[v][g][p] != i[g][p]) return t[0] = g, t[1] = p, i[t[0]][t[1]] = -f, l(), a && (n.winState = "You Lost!"), t;
    return t
   }, C
  }
 }, {
  "./combinations": 1
 }],
 3: [function(r) {
  $(document).ready(function() {
   function e() {
    function r() {
     return o *= -1, 1 === o ? "boardCellCross" : "boardCellCircle"
    }
    if (i) return "";
    var e = $(this);
    if (e.children().hasClass("boardCellCircle")) return "";
    if (e.children().hasClass("boardCellCross")) return "";
    var n = e.children().attr("id").split("-"),
     t = a.makeAnswer(n[0], n[1]);
    if ("" !== t) {
     var f = "#" + t[0] + "-" + t[1];
     $(f).addClass(r())
    } else o *= -1;
    if (e.children().addClass(r()), "" !== a.winState) {
     var u = $("#message");
     u.text(a.winState), i = !0, u.removeClass("looseState"), "You Lost!" === a.winState ? (u.addClass("looseState"), lost()) : won()
    }
   }  
  
  $("#scale-Up").click(handleScale);
  $("#scale-Down").click(handleScale);

  function handleScale(e) {
	var value = 25;
	if ($(window).width() < 450) {
		var maxValue = 550;
	}
	else {
		var maxValue = $(window).width();
	}
	var minValue = 225;
	var delta = $(this).attr('id').split("-")[1];
	var board = $(".board");
	var controls = $(".controls");
	if (delta === "Up" && board.width() < maxValue) {
	  board.width(board.width() + value);
	  board.height(board.height() + value);
	}
	if (delta === "Down" && board.width() > minValue) {
	  board.width(board.width() - value);
	  board.height(board.height() - value);
	}
	if (board.width() == minValue) {
		snacktext = "Maximum Zoom Out level";
		snackactiontext = "";
		snackaction = "";
		snackactioncolor = "";
		snacktimeout = 2000;
		snackoverlay = 0;
		snackhideoverlay = 0;
		snackautohide = 1;
		showsnackbar();

	}
	if (board.width() == maxValue) {
		snacktext = "Maximum Zoom In level";
		snackactiontext = "";
		snackaction = "";
		snackactioncolor = "";
		snacktimeout = 2000;
		snackoverlay = 0;
		snackhideoverlay = 0;
		snackautohide = 1;
		showsnackbar();
	}
   }
   
   function n() {
    var r = $(this).children().attr("id").split("-")[1];
    $(".boardCell").removeClass("boardCellCross boardCellCircle"), i = !1, $("#message").text(""), "O" === r && (a = t(), $("#7-7").addClass("boardCellCross"), o = -1), "X" === r && (a = t(1), o = 1), $("#check").prop("checked", !1)
   }
   var t = r("./gomoku/logic"),
    a = t();
   $("#7-7").addClass("boardCellCross");
   var o = -1,
    i = !1;
   $("div.boardCol").mousedown(e), $("#new-O").parent().click(n); $("#new-X").parent().click(n);
  })
 }, {
  "./gomoku/logic": 2
 }]
}, {}, [3]);

/* WON OR LOST */
var sound = 1;
var tapsound = new Audio("assets/audio/tap.mp3");
var wonsound = new Audio("assets/audio/won.wav");
var lostsound = new Audio("assets/audio/lost.wav");
document.getElementById('setsound').addEventListener('click',checkSound,false);

/* Check Sound */
function checkSound(){ 
  if (document.getElementById('setsound').checked === true) {
	sound = 1;
	snacktext = "Sounds turned ON";
	snackactiontext = "";
	snackaction = "";
	snackactioncolor = "";
	snacktimeout = 2000;
	snackoverlay = 0;
	snackhideoverlay = 0;
	snackautohide = 1;
	showsnackbar();
  } 
  else {
	sound = 0;
	snacktext = "Sounds turned OFF";
	snackactiontext = "";
	snackaction = "";
	snackactioncolor = "";
	snacktimeout = 2000;
	snackoverlay = 0;
	snackhideoverlay = 0;
	snackautohide = 1;
	showsnackbar();
  }
}

$('.boardCol').click(function(){
	tap();
});

function tap() {
    if(sound == 1) {
		tapsound.play();
		tapsound.currentTime=0;
    }
}

function won() {
	snacktext = "You Won!";
	snackactiontext = "SHARE";
    snackaction = "sharePhoto()";
	snackactioncolor = "green";
	snacktimeout = 6000;
    snackoverlay = 1;
    snackhideoverlay = 1;
    snackautohide = 1;
	showsnackbar();
    startVibrate(1000);
    if(sound == 1) {
		wonsound.play();
		wonsound.currentTime=0;
    }
}

function lost() {
	snacktext = "You Lost!";
	snackactiontext = "RETRY";
	snackaction = "play()";
	snackactioncolor = "yellow";
	snacktimeout = 6000;
    snackoverlay = 1;
    snackhideoverlay = 0;
    snackautohide = 1;
	showsnackbar();
    startVibrate(1000);
	if(sound == 1) {
		lostsound.play();
		lostsound.currentTime=0;
	}
}

/* Vibrate */
var vibrate = 1;
document.getElementById('setvibrate').addEventListener('click',checkVibrate,false);

function startVibrate(level) {
	if(vibrate == 1) {
		navigator.vibrate(level);
	}
}

function stopVibrate() {
    navigator.vibrate(0);
}

function checkVibrate(){
  if (document.getElementById('setvibrate').checked === true) {
	vibrate = 1;
    startVibrate(600);
	snacktext = "Vibration turned ON";
	snackactiontext = "";
	snackaction = "";
	snackactioncolor = "";
	snacktimeout = 2000;
	snackoverlay = 0;
	snackhideoverlay = 0;
	snackautohide = 1;
	showsnackbar();
  } 
  else {
	stopVibrate();
	vibrate = 0;
	snacktext = "Vibration turned OFF";
	snackactiontext = "";
	snackaction = "";
	snackactioncolor = "";
	snacktimeout = 2000;
	snackoverlay = 0;
	snackhideoverlay = 0;
	snackautohide = 1;
	showsnackbar();
  }
}

/* Zoom Controls */
document.getElementById('setzoom').addEventListener('click',checkZoom,false);

function checkZoom(){
  if (document.getElementById('setzoom').checked === true) {
	$('.zoom').fadeIn('fast');
	snacktext = "Zoom Enabled";
	snackactiontext = "";
	snackaction = "";
	snackactioncolor = "";
	snacktimeout = 2000;
	snackoverlay = 0;
	snackhideoverlay = 0;
	snackautohide = 1;
	showsnackbar();
  } 
  else {
	$('.zoom').fadeOut('fast');
	snacktext = "Zoom Disabled";
	snackactiontext = "";
	snackaction = "";
	snackactioncolor = "";
	snacktimeout = 2000;
	snackoverlay = 0;
	snackhideoverlay = 0;
	snackautohide = 1;
	showsnackbar();
  }
}

/* Info tour */
jQuery(document).ready(function($){
	//check if a .xo-tour-wrapper exists in the DOM - if yes, initialize it
	$('.xo-tour-wrapper').exists() && initTour();

	function initTour() {
		var tourWrapper = $('.xo-tour-wrapper'),
			tourSteps = tourWrapper.children('li'),
			stepsNumber = tourSteps.length,
			coverLayer = $('.xo-cover-layer'),
			tourStepInfo = $('.xo-more-info'),
			tourTrigger = $('#xo-tour-trigger');

		//create the navigation for each step of the tour
		createNavigation(tourSteps, stepsNumber);
		
		tourTrigger.on('click', function(){
			//start tour
			if(!tourWrapper.hasClass('active')) {
				//in that case, the tour has not been started yet
				tourWrapper.addClass('active');
				showStep(tourSteps.eq(0), coverLayer);
			}
			hidesnackbar();
		});

		//change visible step
		tourStepInfo.on('click', '.xo-prev', function(event){
			//go to prev step - if available
			( !$(event.target).hasClass('inactive') ) && changeStep(tourSteps, coverLayer, 'prev');
		});
		tourStepInfo.on('click', '.xo-next', function(event){
			//go to next step - if available
			( !$(event.target).hasClass('inactive') ) && changeStep(tourSteps, coverLayer, 'next');
		});

		//close tour
		tourStepInfo.on('click', '.xo-close', function(event){
			closeTour(tourSteps, tourWrapper, coverLayer);
			hidesnackbar();
		});

		//detect swipe event on mobile - change visible step
		tourStepInfo.on('swiperight', function(event){
			//go to prev step - if available
			if( !$(this).find('.xo-prev').hasClass('inactive') && viewportSize() == 'mobile' ) changeStep(tourSteps, coverLayer, 'prev');
		});
		tourStepInfo.on('swipeleft', function(event){
			//go to next step - if available
			if( !$(this).find('.xo-next').hasClass('inactive') && viewportSize() == 'mobile' ) changeStep(tourSteps, coverLayer, 'next');
		});

		//keyboard navigation
		$(document).keyup(function(event){
			if( event.which=='37' && !tourSteps.filter('.is-selected').find('.xo-prev').hasClass('inactive') ) {
				changeStep(tourSteps, coverLayer, 'prev');
			} else if( event.which=='39' && !tourSteps.filter('.is-selected').find('.xo-next').hasClass('inactive') ) {
				changeStep(tourSteps, coverLayer, 'next');
			} else if( event.which=='27' ) {
				closeTour(tourSteps, tourWrapper, coverLayer);
			}
		});
	}

	function createNavigation(steps, n) {
		var tourNavigationHtml = '<div class="xo-nav"><span><b class="xo-actual-step">1</b> of '+n+'</span><ul class="xo-tour-nav"><li><a href="#" class="xo-prev waves-attach waves-button">&#171; Previous</a></li><li><a href="#" class="xo-next waves-attach waves-button">Next &#187;</a></li></ul></div><a href="#" class="xo-close">Close</a>';

		steps.each(function(index){
			var step = $(this),
				stepNumber = index + 1,
				nextClass = ( stepNumber < n ) ? '' : 'inactive',
				prevClass = ( stepNumber == 1 ) ? 'inactive' : '';
			var nav = $(tourNavigationHtml).find('.xo-next').addClass(nextClass).end().find('.xo-prev').addClass(prevClass).end().find('.xo-actual-step').html(stepNumber).end().appendTo(step.children('.xo-more-info'));
		});
	}

	function showStep(step, layer) {
		step.addClass('is-selected').removeClass('move-left');
		smoothScroll(step.children('.xo-more-info'));
		showLayer(layer);
	}

	function smoothScroll(element) {
		(element.offset().top < $(window).scrollTop()) && $('body,html').animate({'scrollTop': element.offset().top}, 100);
		(element.offset().top + element.height() > $(window).scrollTop() + $(window).height() ) && $('body,html').animate({'scrollTop': element.offset().top + element.height() - $(window).height()}, 100); 
	}

	function showLayer(layer) {
		layer.addClass('is-visible').on('webkitAnimationEnd oanimationend msAnimationEnd animationend', function(){
			layer.removeClass('is-visible');
		});
	}

	function changeStep(steps, layer, bool) {
		var visibleStep = steps.filter('.is-selected'),
			delay = (viewportSize() == 'desktop') ? 300: 0; 
		visibleStep.removeClass('is-selected');

		(bool == 'next') && visibleStep.addClass('move-left');

		setTimeout(function(){
			( bool == 'next' )
				? showStep(visibleStep.next(), layer)
				: showStep(visibleStep.prev(), layer);
		}, delay);
	}

	function closeTour(steps, wrapper, layer) {
		steps.removeClass('is-selected move-left');
		wrapper.removeClass('active');
		layer.removeClass('is-visible');
	}

	function viewportSize() {
		/* retrieve the content value of .xo-main::before to check the actua mq */
		return window.getComputedStyle(document.querySelector('.xo-tour-wrapper'), '::before').getPropertyValue('content').replace(/"/g, "").replace(/'/g, "");
	}
});

//check if an element exists in the DOM
jQuery.fn.exists = function(){ return this.length > 0; }